library(repeated)

data <- read.list("bloodglu.dat",skip=4,nlines=1)
times <- c(-15, 0, 30, 60, 90, 120, 180, 240, 300, 360, 420)
baseline <- NULL
for(i in 1:length(data))baseline <- c(baseline,data[[i]][1])
for(i in 1:length(data))
	data[[i]] <- cbind(data[[i]][-1],times[2:length(data[[i]])])
rm(times)
reps <- rmna(restovec(data,delta=0.01))
hour <- rep(codes(gl(6,6)),nobs(reps))
baseline <- rep(baseline,nobs(reps))
reps$resp$times <- ifelse(times(reps)==0,0.01,times(reps))

mu0 <- function(p){
	ka <- exp(p[2])
	ke <- exp(p[3])
	p[4]*(1+exp(p[2]-p[1])*baseline/(ka-ke)*
		(exp(-ke*times(reps))-exp(-ka*times(reps))))}
mu1 <- function(p){
	ka <- exp(p[2])
	ke <- exp(p[3])
	p[4]*(1+exp(p[2]-p[1]-p[5]*(hour==2)-p[6]*(hour==3)-
		p[7]*(hour==4)-p[8]*(hour==5)-p[9]*(hour==6))*baseline/(ka-ke)*
		(exp(-ke*times(reps))-exp(-ka*times(reps))))}
mu2 <- function(p){
	ka <- exp(p[2])
	ke <- exp(p[3]+p[5]*(hour==2)+p[6]*(hour==3)+
		p[7]*(hour==4)+p[8]*(hour==5)+p[9]*(hour==6))
	p[4]*(1+exp(p[2]-p[1])*baseline/(ka-ke)*
		(exp(-ke*times(reps))-exp(-ka*times(reps))))}
mu2s <- function(p){
	ka <- exp(p[2])
	ke <- exp(p[3]+p[5]*(hour==2)+p[6]*(hour==3)+
		p[7]*(hour==4)+p[7]*(hour==5))
	p[4]*(1+exp(p[2]-p[1])*baseline/(ka-ke)*
		(exp(-ke*times(reps))-exp(-ka*times(reps))))}
mu3 <- function(p){
	ka <- exp(p[2])
	ke <- exp(p[3]+p[5]*(hour==2)+p[6]*(hour==3)+
		p[7]*(hour==4)+p[8]*(hour==5)+p[9]*(hour==6))
	p[4]*(1+exp(p[2]-p[1]-p[10]*(hour==2)-p[11]*(hour==3)-p[12]*(hour==4)-
		p[13]*(hour==5)-p[14]*(hour==6))*baseline/(ka-ke)*
		(exp(-ke*times(reps))-exp(-ka*times(reps))))}
mu3s <- function(p){
	ka <- exp(p[2])
	ke <- exp(p[3]+p[5]*(hour==2)+p[6]*(hour==3)+
		p[7]*(hour==4)+p[7]*(hour==5))
	p[4]*(1+exp(p[2]-p[1]-p[8]*(hour==3))*baseline/(ka-ke)*
		(exp(-ke*times(reps))-exp(-ka*times(reps))))}
mu4 <- function(p){
	ka <- exp(p[2]+p[10]*(hour==2)+p[11]*(hour==3)+p[12]*(hour==4)+
		p[13]*(hour==5)+p[14]*(hour==6))
	ke <- exp(p[3]+p[5]*(hour==2)+p[6]*(hour==3)+
		p[7]*(hour==4)+p[8]*(hour==5)+p[9]*(hour==6))
	p[4]*(1+exp(p[2]-p[1]+p[10]*(hour==2)+p[11]*(hour==3)+p[12]*(hour==4)+
		p[13]*(hour==5)+p[14]*(hour==6))*baseline/(ka-ke)*
		(exp(-ke*times(reps))-exp(-ka*times(reps))))}

if(interactive()){
main <- c("2:00","6:00","10:00","14:00","18:00","22:00")
xlab <- c("","","","","Minutes","Minutes")
ylab <- c("Blood glucose","","Blood glucose","","Blood glucose","")
postscript("bloodglu.eps")
par(mfrow=c(3,2),font.main=1)
for(i in 1:6){
	plot(data[[(i-1)*6+1]][,2],data[[(i-1)*6+1]][,1],type="l",ylim=c(0,12),
		xlim=c(0,420),xlab=xlab[i],ylab=ylab[i],main=main[i])
	points(data[[(i-1)*6+1]][,2],data[[(i-1)*6+1]][,1])
	for(j in 2:6){
		lines(data[[(i-1)*6+j]][,2],data[[(i-1)*6+j]][,1])
		points(data[[(i-1)*6+1]][,2],data[[(i-1)*6+j]][,1],pch=j)}}
}

print(u0n <- kalseries(reps,intens="normal",mu=mu0,
	ptvc=c(2,-2.6,-4.9,4),dep="Markov",pdep=0.9,psh=1))
print(u0g <- kalseries(reps,intens="gamma",mu=mu0,pinit=0.3,
	ptvc=c(1.6,-3.14,-4.5,0.14),dep="Markov",pdep=0.99,psh=20))
print(u0w <- kalseries(reps,intens="Weibull",mu=mu0,
	ptvc=c(1.6,-2.6,-4,4),dep="Markov",pdep=0.9,psh=2))
print(u0ln <- kalseries(reps,intens="normal",mu=mu0,trans="log",
	link="exp",ptvc=c(1.5,-3,-4.4,1.5),dep="Markov",
	pdep=0.98,psh=0.3,pinit=0.1))
print(u0ll <- kalseries(reps,intens="logistic",mu=mu0,trans="log",
	link="exp",ptvc=c(1.5,-3,-4.4,1.5),dep="Markov",pinit=0.1,
	pdep=0.9,psh=0.1))
print(u0lc <- kalseries(reps,intens="Cauchy",mu=mu0,trans="log",
	link="exp",ptvc=c(1.5,-3,-4.4,1.5),dep="Markov",
	pdep=0.9,psh=0.1,pinit=1))
rm(u0n,u0g,u0w,u0ln,u0ll,u0lc)

print(u2n <- kalseries(reps,intens="normal",mu=mu2,
	ptvc=c(1,-4,-4.3,4,0,0,0,0,0),dep="Markov",pdep=0.8,psh=1))
print(u2g <- kalseries(reps,intens="gamma",mu=mu2,
	ptvc=c(1.6,-3.1,-4.5,0.14,0,0,0,0,0),dep="Markov",pinit=0.3,
	pdep=0.999,psh=10,iter=200))
print(u2w <- kalseries(reps,intens="Weibull",mu=mu2,
	ptvc=c(1,-4,-4.3,4,0,0,0,0,0),dep="Markov",pdep=0.8,psh=0.1))
print(u2ln <- kalseries(reps,intens="normal",mu=mu2,trans="log",
	link="exp",ptvc=c(1.5,-3.7,-4.4,1.5,0.6,1.3,0.4,0.4,0),dep="Markov",
	pdep=0.9,psh=1,pinit=2))
print(u2ll <- kalseries(reps,intens="logistic",mu=mu2,trans="log",
	link="exp",ptvc=c(1.5,-3.7,-4.4,1.5,0.6,1.3,0.4,0.4,0),dep="Markov",
	pdep=0.98,psh=0.1))
print(u2lc <- kalseries(reps,intens="Cauchy",mu=mu2,trans="log",
	link="exp",ptvc=c(1.5,-3.7,-4.4,1.5,0.6,1.3,0.4,0.4,0),dep="Markov",
	pdep=0.9,psh=1,pinit=1))
rm(u2n,u2g,u2w,u2ln,u2ll,u2lc)

print(u3n <- kalseries(reps,intens="normal",mu=mu3,
	ptvc=c(1.5,-3.7,-4.3,4.5,0,0,0,0,0,0,0,0,0,0),dep="Markov",
	pdep=0.99,psh=0.7,pinit=0.25))
print(u3g <- kalseries(reps,intens="gamma",mu=mu3,pinit=0.08,
	ptvc=c(0.85,-3.8,-4.4,0.09,0.83,6.63,0.32,0.68,0.06,-0.1,-5.5,0.1,
	-0.16,-0.07),dep="Markov",pdep=0.99,psh=10,iter=200))
print(u3w <- kalseries(reps,intens="Weibull",mu=mu3,
	ptvc=c(0.8,-3.9,-4.3,4.7,1,6,0.3,0.75,0.1,-0.2,-5,0.1,-0.18,-0.16),
	dep="Markov",pinit=0.11,pdep=0.8,psh=1))
print(u3ln <- kalseries(reps,intens="normal",mu=mu3,trans="log",
	link="exp",ptvc=c(1.5,-3.7,-4.4,1.5,0.6,1.3,0.4,0.4,0,0,0,0,0,0),
	dep="Markov",pdep=0.98,psh=0.03,pinit=0.15,iter=200))
print(u3ll <- kalseries(reps,intens="logistic",mu=mu3,trans="log",
	link="exp",ptvc=c(1.5,-3.7,-4.4,1.5,0.6,1.3,0.4,0.4,0,0,0,0,0,0),
	dep="Markov",pdep=0.9,psh=1,pinit=0.1))
print(u3lc <- kalseries(reps,intens="Cauchy",mu=mu3,trans="log",
	link="exp",ptvc=c(1.7,-3.5,-4.5,1.5,0.8,6.7,0.2,0.5,0.1,-0.1,-5.6,
	0.2,0,-0.1),dep="Markov",pdep=0.99,psh=0.006,pinit=0.1,iter=200))
rm(u3n,u3g,u3w,u3ln,u3ll,u3lc)

print(u4n <- kalseries(reps,intens="normal",mu=mu4,pdep=0.99,psh=0.7,
	ptvc=c(1.5,-3.7,-4.3,4.5,0,0,0,0,0,0,0,0,0,0),dep="Markov",pinit=0.25))
print(u4g <- kalseries(reps,intens="gamma",mu=mu4,pinit=0.3,
	ptvc=c(1.6,-3.1,-4.5,0.14,0.83,6.63,0.32,0.68,0,0,0,0,0,0),
	dep="Markov",pdep=0.99,psh=10,iter=300))
print(u4w <- kalseries(reps,intens="Weibull",mu=mu4,
	ptvc=c(0.8,-3.9,-4.3,4.7,1,6,0.3,0.75,0.1,-0.2,-5,0.1,-0.18,-0.16),
	dep="Markov",pinit=0.11,pdep=0.8,psh=1))
print(u4ln <- kalseries(reps,intens="normal",mu=mu4,trans="log",link="exp",
	ptvc=c(1.4,-3.7,-4.4,1.5,0.76,1.5,0.5,0.6,0,0.5,1.4,0.3,0.5,0.2),
	dep="Markov",pdep=0.98,psh=0.03,pinit=0.15,iter=200))
print(u4ll <- kalseries(reps,intens="logistic",mu=mu4,trans="log",
	link="exp",ptvc=c(1.5,-3.7,-4.4,1.5,0.6,1.3,0.4,0.4,0,0,0,0,0,0),
	dep="Markov",pdep=0.99,psh=0.1,pinit=0.1))
print(u4lc <- kalseries(reps,intens="Cauchy",mu=mu4,trans="log",
	link="exp",ptvc=c(1.5,-3.7,-4.4,1.5,0.6,1.3,0.4,0.4,0,0,0,0,0,0),
	dep="Markov",pdep=0.99,psh=0.02,pinit=0.1,iter=200))
rm(u4n,u4g,u4w,u4ln,u4ll,u4lc)

print(u0sn <- kalseries(reps,intens="normal",mu=mu0,
	ptvc=c(2,-2.6,-4.9,4),dep="serial",pdep=0.9,psh=1))
#print(u0sg <- kalseries(reps,intens="gamma",mu=mu0,
#	ptvc=c(2,-2.6,-4.9,4),dep="serial",pdep=0.8,psh=1))
print(u0sw <- kalseries(reps,intens="Weibull",mu=mu0,
	ptvc=c(1.6,-2.6,-4,4),dep="serial",pdep=0.9,psh=2))
print(u0sln <- kalseries(reps,intens="normal",mu=mu0,trans="log",
	link="exp",ptvc=c(1.5,-3,-4.4,1.5),dep="serial",
	pdep=0.98,psh=0.3,pinit=0.1))
print(u0sll <- kalseries(reps,intens="logistic",mu=mu0,trans="log",
	link="exp",ptvc=c(1.5,-3,-4.4,1.5),dep="serial",
	pdep=0.9,psh=0.1))
print(u0slc <- kalseries(reps,intens="Cauchy",mu=mu0,trans="log",
	link="exp",ptvc=c(1.5,-3,-4.4,1.5),dep="serial",
	pdep=0.9,psh=0.1,pinit=1))
rm(u0sn,u0sg,u0sw,u0sln,u0sll,u0slc)

print(u1sn <- kalseries(reps,intens="normal",mu=mu1,
	ptvc=c(2,-2.6,-4.9,4,0,0,0,0,0),dep="serial",pdep=0.9,psh=1))
#print(u1sg <- kalseries(reps,intens="gamma",mu=mu1,
#	ptvc=c(2,-2.6,-4.9,4,0,0,0,0,0),dep="serial",pdep=0.8,psh=1))
print(u1sw <- kalseries(reps,intens="Weibull",mu=mu1,
	ptvc=c(1,-3.3,-4.5,4.7,0,0,0,0,0),dep="serial",pdep=0.98,psh=2))
print(u1sln <- kalseries(reps,intens="normal",mu=mu1,trans="log",
	link="exp",ptvc=c(1.5,-3.7,-4.4,1.5,0,0,0,0,0),dep="serial",
	pdep=0.98,psh=0.3,pinit=0.1))
print(u1sll <- kalseries(reps,intens="logistic",mu=mu1,trans="log",
	link="exp",ptvc=c(1.5,-3,-4.4,1.5,0,0,0,0,0),dep="serial",
	pdep=0.9,psh=0.1))
print(u1slc <- kalseries(reps,intens="Cauchy",mu=mu1,trans="log",
	link="exp",ptvc=c(1.5,-3,-4.4,1.5,0,0,0,0,0),dep="serial",
	pdep=0.99,psh=0.005,pinit=0.0001,iter=200))
rm(u1sn,u1sg,u1sw,u1sln,u1sll,u1slc)

print(u2sn <- kalseries(reps,intens="normal",mu=mu2,dep="serial",
	ptvc=c(1.5,-3.7,-4.5,4.5,0,0,0,0,0),pdep=0.9,psh=2))
#print(u2sg <- kalseries(reps,intens="gamma",mu=mu2,dep="serial",
#	ptvc=c(1.5,-3.7,-4.4,4.5,0.6,1.3,0.4,0.4,0),pdep=0.8,psh=1))
print(u2sw <- kalseries(reps,intens="Weibull",mu=mu2,
	ptvc=c(1,-4,-4.3,4,0,0,0,0,0),dep="serial",pdep=0.8,psh=1))
print(u2sln <- kalseries(reps,intens="normal",mu=mu2,trans="log",
	link="exp",ptvc=c(1.5,-3.7,-4.4,1.5,0.6,1.3,0.4,0.4,0),dep="serial",
	pdep=0.98,psh=0.3,pinit=0.1))
print(u2sll <- kalseries(reps,intens="logistic",mu=mu2,trans="log",
	link="exp",ptvc=c(1.5,-3.7,-4.4,1.5,0.6,1.3,0.4,0.4,0),dep="serial",
	pdep=0.65,psh=0.1))
print(u2slc <- kalseries(reps,intens="Cauchy",mu=mu2,trans="log",
	link="exp",ptvc=c(1.53,-3.64,-4.35,1.48,0.61,1.45,0.54,0.48,-0.03),
	dep="serial",pdep=0.995,psh=0.005,pinit=0.00001,iter=200))
rm(u2sn,u2sg,u2sw,u2sln,u2sll,u2slc)

print(u3sn <- kalseries(reps,intens="normal",mu=mu3,dep="serial",
	ptvc=c(1.5,-3.7,-4.3,4.5,0,0,0,0,0,0,0,0,0,0),pdep=0.9,psh=2))
#print(u3sg <- kalseries(reps,intens="gamma",mu=mu3,dep="serial",
#	ptvc=c(1.5,-3.7,-4.4,4.5,0.6,1.3,0.4,0.4,0,0,0,0,0,0),pdep=0.8,psh=1))
print(u3sw <- kalseries(reps,intens="Weibull",mu=mu3,
	ptvc=c(0.8,-3.9,-4.3,4.7,1,6,0.3,0.75,0.1,-0.2,-5,0.1,-0.18,-0.16),
	dep="serial",pinit=0.11,pdep=0.8,psh=1))
print(u3sln <- kalseries(reps,intens="normal",mu=mu3,trans="log",
	link="exp",ptvc=c(1.47,-3.88,-4.35,1.45,0.81,7.14,0.34,0.68,0,-0.2,
	-6.14,0,-0.24,-0.05),
	dep="serial",pdep=0.99,psh=0.021,pinit=0.001,iter=200))
print(u3sll <- kalseries(reps,intens="logistic",mu=mu3,trans="log",
	link="exp",ptvc=c(1.5,-3.8,-4.37,1.47,0.78,4.26,0.36,0.67,0.06,
	-0.12,-3.22,0.07,-0.18,-0.07),
	dep="serial",pdep=0.71,psh=0.006,pinit=0.01,iter=200))
print(u3slc <- kalseries(reps,intens="Cauchy",mu=mu3,trans="log",
	link="exp",ptvc=c(1.62,-3.5,-4.46,1.48,0.71,3.68,0.29,0.42,0.09,
	-0.09,2.63,0.18,0.06,-0.09),
	dep="serial",pdep=0.95,psh=0.005,pinit=0.01,iter=200))
rm(u3sn,u3sg,u3sw,u3sln,u3sll,u3slc)

print(u4sn <- kalseries(reps,intens="normal",mu=mu4,pdep=0.9,psh=2,
	ptvc=c(1.5,-3.7,-4.3,4.5,0,0,0,0,0,0,0,0,0,0),dep="serial",iter=200))
#print(u4sg <- kalseries(reps,intens="gamma",mu=mu4,
#	ptvc=c(1.5,-3.7,-4.4,4.5,0.6,1.3,0.4,0.4,0,0,0,0,0,0),dep="serial",
#	pdep=0.8,psh=1))
print(u4sw <- kalseries(reps,intens="Weibull",mu=mu4,
	ptvc=c(0.8,-3.9,-4.3,4.7,1,6,0.3,0.75,0.1,-0.2,-5,0.1,-0.18,-0.16),
	dep="serial",pinit=0.11,pdep=0.8,psh=1))
print(u4sln <- kalseries(reps,intens="normal",mu=mu4,trans="log",
	link="exp",ptvc=c(1.4,-3.7,-4.4,1.5,0.76,1.5,0.5,0.6,0,0.5,1.4,0.3,0.5,0.2),
	dep="serial",pdep=0.98,psh=0.03,pinit=0.15,iter=200))
print(u4sll <- kalseries(reps,intens="logistic",mu=mu4,trans="log",
	link="exp",ptvc=c(1.29,-4.04,-4.12,1.47,0.61,1.31,0.37,0.44,-0.04,
	0.2,0.87,-0.03,0.19,0.06),
	dep="serial",pdep=0.93,psh=0.01,pinit=0.001,iter=200))
print(u4slc <- kalseries(reps,intens="Cauchy",mu=mu4,trans="log",
	link="exp",ptvc=c(1.5,-3.7,-4.4,1.5,0.6,1.3,0.4,0.4,0,0,0,0,0,0),
	dep="serial",pdep=0.92,psh=0.1,pinit=0.1,iter=200))
rm(u4sn,u4sg,u4sw,u4sln,u4sll,u4slc)

print(u2lns <- kalseries(reps,intens="normal",mu=mu2s,trans="log",
	link="exp",ptvc=c(1.5,-3.7,-4.4,1.5,0.6,1.3,0.4),dep="Markov",
	pdep=0.9,psh=1,pinit=5))
print(u2slns <- kalseries(reps,intens="normal",mu=mu2s,trans="log",
	link="exp",ptvc=c(1.53,-3.73,-4.41,1.46,0.64,1.33,0.43),dep="serial",
	pdep=0.99,psh=0.23,pinit=0.0001))
exp(u2slns$coef[4])
print(u2ilns <- kalseries(reps,intens="normal",mu=mu2s,trans="log",
	link="exp",ptvc=c(1.5,-3.7,-4.4,1.5,0.6,1.3,0.4),dep="indep",
	psh=0.03,pinit=5))
print(u2flns <- kalseries(reps,intens="normal",mu=mu2s,trans="log",
	link="exp",ptvc=c(1.53,-3.72,-4.42,1.46,0.64,1.33,0.43),dep="frailty",
	psh=0.022,pinit=0.0001))
rm(u2lns,u2slns,u2ilns,u2flns)

print(u2ws <- kalseries(reps,intens="Weibull",mu=mu2s,
	ptvc=c(1,-4,-4.3,4,0,0,0),dep="Markov",pdep=0.8,psh=1))
print(u2sws <- kalseries(reps,intens="Weibull",mu=mu2s,
	ptvc=c(1,-4,-4.3,4,0,0,0),dep="serial",pdep=0.8,psh=1))
print(u2fws <- kalseries(reps,intens="Weibull",mu=mu2s,
	ptvc=c(1,-4,-4.3,4,0,0,0),dep="frailty",psh=1))
print(u2iws <- kalseries(reps,intens="Weibull",mu=mu2s,
	ptvc=c(1,-4,-4.3,4,0,0,0),dep="indep",psh=1))
print(u3ws <- kalseries(reps,intens="Weibull",mu=mu3s,
	ptvc=c(1,-4,-4.3,4,0,0,0,0),dep="Markov",pdep=0.8,psh=1))

if(interactive()){
mu2ssp <- function(p,times){
	ka <- exp(p[2])
	ke <- exp(p[3]+p[5]*(i==2)+p[6]*(i==3)+p[7]*(i==4)+p[7]*(i==5))
	p[4]*(1+exp(p[2]-p[1])*data[[(i-1)*6+1]][1]/(ka-ke)*
		(exp(-ke*times)-exp(-ka*times)))}
main <- c("2:00","6:00","10:00","14:00","18:00","22:00")
#postscript("bldglpr1.eps")
par(mfrow=c(3,2),font.main=1)
for(i in 1:6){
	plot(seq(0,420,by=10),mu2ssp(u2sws$coef,seq(0,420,by=10)),
		xlab="Minutes",ylab="Blood glucose",main=main[i],
		type="l",ylim=c(0,12))
	for(j in 1:6)points(data[[(i-1)*6+j]][,2],data[[(i-1)*6+j]][,1],pch=j)}
}

if(interactive()){
mu3p <- function(p,times){
	ka <- exp(p[2])
	ke <- exp(p[3]+p[5]*(hr==2)+p[6]*(hr==3)+
		p[7]*(hr==4)+p[8]*(hr==5)+p[9]*(hr==6))
	p[4]*(1+exp(p[2]-p[1]-p[10]*(hr==2)-p[11]*(hr==3)-p[12]*(hr==4)-
		p[13]*(hr==5)-p[14]*(hr==6))*4.54/(ka-ke)*
		(exp(-ke*times)-exp(-ka*times)))}
mu3sp <- function(p,times){
	ka <- exp(p[2])
	ke <- exp(p[3]+p[5]*(hr==2)+p[6]*(hr==3)+
		p[7]*(hr==4)+p[7]*(hr==5))
	p[4]*(1+exp(p[2]-p[1]-p[8]*(hr==3))*4.54/(ka-ke)*
		(exp(-ke*times)-exp(-ka*times)))}
main <- c("2:00","6:00","10:00","14:00","18:00","22:00")
xlab <- c("","","","","Minutes","Minutes")
ylab <- c("Blood glucose","","Blood glucose","","Blood glucose","")
postscript("bldglpr1.eps")
par(mfrow=c(3,2),font.main=1)
j <- 1
for(i in 1:6){
	plot(iprofile(u3ws),nind=c((i-1)*6+j,(i-1)*6+j+1),lty=c(2,3),
		pch=c(1,2),ylim=c(0,12),
		xlab=xlab[i],ylab=ylab[i],main=main[i])
	hr <- i
	plot(mprofile(u3ws,times=seq(0,420,by=20),mu=mu3sp),add=T)}
}

print(z0n <- gar(reps,"normal",mu=mu0,preg=c(1.6,-2.6,-4.9,4.3),
	pdep=0.9,psh=1))
print(z0g <-gar(reps,"gamma",mu=mu0,preg=c(1.6,-2.6,-4.9,4.3),pdep=0.9,psh=1))
print(z0w <- gar(reps,"Weibull",mu=mu0,preg=c(1.6,-2.6,-4.9,4.3),
	pdep=0.9,psh=1))
print(z0ln <- gar(reps,"normal",mu=mu0,preg=c(1.6,-2.6,-4.9,4.3),
	trans="log",link="exp",pdep=0.9,psh=1))
print(z0ll <- gar(reps,"logistic",mu=mu0,preg=c(1.6,-2.6,-4.9,4.3),
	trans="log",link="exp",pdep=0.9,psh=1))
print(z0lc <- gar(reps,"Cauchy",mu=mu0,preg=c(1.6,-2.6,-4.9,4.3),
	trans="log",link="exp",pdep=0.9,psh=1))

if(interactive()){
par(mfrow=c(3,2))
for(i in 1:6)plot(iprofile(z0),nind=(i-1)*6+1)
}
rm(z0n,z0g,z0w,z0ln,z0ll,z0lc)

print(z1n <- gar(reps,mu=mu1,preg=c(1.6,-2.6,-4.9,4.3,0,0,0,0,0),
	pdep=0.9,psh=1))
print(z1g <- gar(reps,"gamma",mu=mu1,
	preg=c(1.6,-2.6,-4.9,4.3,0,0,0,0,0),pdep=0.9,psh=1))
print(z1w <- gar(reps,"Weibull",mu=mu1,
	preg=c(1.6,-2.6,-4.9,4.3,0,0,0,0,0),pdep=0.9,psh=1))
print(z1ln <- gar(reps,"normal",mu=mu1,trans="log",link="exp",
	preg=c(1.6,-3,-4.9,4.3,0,0,0,0,0),pdep=0.95,psh=0.3))
print(z1ll <- gar(reps,"logistic",mu=mu1,trans="log",link="exp",
	preg=c(1.6,-2.6,-4.9,4.3,0,0,0,0,0),pdep=0.9,psh=1))
print(z1lc <- gar(reps,"Cauchy",mu=mu1,trans="log",link="exp",
	preg=c(1.6,-2.6,-4.9,4.3,0,0,0,0,0),pdep=0.9,psh=1))

if(interactive()){
mu1p <- function(p,times){
	ka <- exp(p[2])
	ke <- exp(p[3])
	p[4]*(1+exp(p[2]-p[1]-p[5]*(i==2)-p[6]*(i==3)-p[7]*(i==4)-
		p[8]*(i==5)-p[9]*(i==6))*data[[(i-1)*6+j]][1]/(ka-ke)*
		(exp(-ke*times)-exp(-ka*times)))}
par(mfrow=c(3,2),font.main=1)
j <- 1
main <- c("2:00, Subject","6:00, Subject","10:00, Subject",
	"14:00, Subject","18:00, Subject","22:00, Subject")
for(i in 1:6){
	plot(iprofile(z1ll),nind=(i-1)*6+j,lty=3,xlab="Minutes",
		ylab="Blood glucose",main=main[i])
	plot(mprofile(z1ll,times=seq(0,420,by=20),mu=mu1p),add=T)}
}
rm(z1n,z1g,z1w,z1ln,z1ll,z1lc)

print(z2n <- gar(reps,mu=mu2,preg=c(1.6,-2.6,-4.9,4.3,0,0,0,0,0),
	pdep=0.9,psh=1))
print(z2g <- gar(reps,"gamma",mu=mu2,
	preg=c(1.6,-2.6,-4.9,4.3,0,0,0,0,0),pdep=0.9,psh=1))
print(z2w <- gar(reps,"Weibull",mu=mu2,iter=200,
	preg=c(0.64,-3.8,-4.2,4.6,0.76,1.1,0.4,0.4,0),pdep=0.95,psh=2))
print(z2ln <- gar(reps,"normal",mu=mu2,trans="log",link="exp",
	preg=c(1.6,-3,-4.9,4.3,0,0,0,0,0),pdep=0.95,psh=0.3))
print(z2ll <- gar(reps,"logistic",mu=mu2,trans="log",link="exp",
	preg=c(1.6,-2.6,-4.9,4.3,0,0,0,0,0),pdep=0.9,psh=1))
print(z2lc <- gar(reps,"Cauchy",mu=mu2,trans="log",link="exp",
	preg=c(1.6,-2.6,-4.9,4.3,0,0,0,0,0),pdep=0.9,psh=1))

print(z2ws <- gar(reps,"Weibull",mu=mu2s,trans="log",link="exp",
	preg=c(1.6,-2.6,-4.9,4.3,0,0,0),pdep=0.9,psh=1))

if(interactive()){
mu2p <- function(p,times){
	ka <- exp(p[2])
	ke <- exp(p[3]+p[5]*(i==2)+p[6]*(i==3)+p[7]*(i==4)+
		p[8]*(i==5)+p[9]*(i==6))
	p[4]*(1+exp(p[2]-p[1])*data[[(i-1)*6+j]][1]/(ka-ke)*
		(exp(-ke*times)-exp(-ka*times)))}
mu2sp <- function(p,times){
	ka <- exp(p[2])
	ke <- exp(p[3]+p[5]*(i==2)+p[6]*(i==3)+p[7]*(i==4)+p[7]*(i==5))
	p[4]*(1+exp(p[2]-p[1])*data[[(i-1)*6+j]][1]/(ka-ke)*
		(exp(-ke*times)-exp(-ka*times)))}
postscript("bldglpr2.eps")
par(mfrow=c(3,2),font.main=1)
j <- 1
for(i in 1:6){
	plot(iprofile(z2ws),nind=c((i-1)*6+j,(i-1)*6+j+1),lty=c(2,3),
		pch=c(1,2),ylim=c(0,12),xlab=xlab[i],ylab=ylab[i],main=main[i])
	plot(mprofile(z2ws,times=seq(0,420,by=20),mu=mu2sp),add=T)}
}
rm(z2n,z2g,z2w,z2ln,z2ll,z2lc)

print(z3n <- gar(reps,mu=mu3,preg=c(1.6,-2.6,-4.9,4.3,rep(0,10)),
	pdep=0.9,psh=1))
print(z3g <- gar(reps,"gamma",mu=mu3,
	preg=c(1.6,-2.6,-4.9,4.3,rep(0,10)),pdep=0.9,psh=1))
print(z3w <- gar(reps,"Weibull",mu=mu3,
	preg=c(1.6,-2.6,-4.9,4.3,rep(0,10)),pdep=0.9,psh=1))
print(z3ln <- gar(reps,"normal",mu=mu3,trans="log",link="exp",
	preg=c(1.6,-3,-4.9,4.3,rep(0,10)),pdep=0.95,psh=0.3))
print(z3ll <- gar(reps,"logistic",mu=mu3,trans="log",link="exp",
	preg=c(1.6,-2.6,-4.9,4.3,rep(0,10)),pdep=0.9,psh=1))
print(z3lc <- gar(reps,"Cauchy",mu=mu3,trans="log",link="exp",
	preg=c(1.6,-2.6,-4.9,4.3,rep(0,10)),pdep=0.9,psh=1))

if(interactive()){
mu3p <- function(p,times){
	ka <- exp(p[2])
	ke <- exp(p[3]+p[5]*(i==2)+p[6]*(i==3)+p[7]*(i==4)+
		p[8]*(i==5)+p[9]*(i==6))
	p[4]*(1+exp(p[2]-p[1]-p[10]*(i==2)-p[11]*(i==3)-p[12]*(i==4)-
		p[13]*(i==5)-p[14]*(i==6))*data[[(i-1)*6+j]][1]/(ka-ke)*
		(exp(-ke*times)-exp(-ka*times)))}
par(mfrow=c(3,2),font.main=1)
j <- 1
for(i in 1:6){
	plot(iprofile(z3ll),nind=(i-1)*6+j,lty=3,xlab="Minutes",
		ylab="Blood glucose",main=main[i])
	plot(mprofile(z3ll,times=seq(0,420,by=20),mu=mu3p),add=T)}
}
rm(z3n,z3g,z3w,z3ln,z3ll,z3lc)

print(z4n <- gar(reps,mu=mu4,preg=c(1.6,-2.6,-4.9,4.3,rep(0,10)),
	pdep=0.9,psh=1))
print(z4g <- gar(reps,"gamma",mu=mu4,
	preg=c(1.6,-2.6,-4.9,4.3,rep(0,10)),pdep=0.9,psh=1))
print(z4w <- gar(reps,"Weibull",mu=mu4,
	preg=c(1.6,-2.6,-4.9,4.3,rep(0,10)),pdep=0.9,psh=1))
print(z4ln <- gar(reps,"normal",mu=mu4,trans="log",link="exp",
	preg=c(1.6,-3,-4.9,4.3,rep(0,10)),pdep=0.95,psh=0.3))
print(z4ll <- gar(reps,"logistic",mu=mu4,trans="log",link="exp",
	preg=c(1.6,-2.6,-4.9,4.3,rep(0,10)),pdep=0.9,psh=1))
print(z4lc <- gar(reps,"Cauchy",mu=mu4,trans="log",link="exp",
	preg=c(1.6,-2.6,-4.9,4.3,rep(0,10)),pdep=0.9,psh=1))

if(interactive()){
mu4p <- function(p,times){
	ka <- exp(p[2])
	ke <- exp(p[3]+p[5]*(i==2)+p[6]*(i==3)+p[7]*(i==4)+
		p[8]*(i==5)+p[9]*(i==6))
	p[4]*(1+exp(p[2]-p[1]-p[10]*(i==2)-p[11]*(i==3)-p[12]*(i==4)-
		p[13]*(i==5)-p[14]*(i==6))*data[[(i-1)*6+j]][1]/(ka-ke)*
		(exp(-ke*times)-exp(-ka*times)))}
par(mfrow=c(3,2),font.main=1)
j <- 1
for(i in 1:6){
	plot(iprofile(z4ll),nind=(i-1)*6+j,lty=3,xlab="Minutes",
		ylab="Blood glucose",main=main[i])
	plot(mprofile(z4ll,times=seq(0,420,by=20),mu=mu4p),add=T)}
}
