library(gnlm)
library(repeated)

data <- cbind(rep(0,8),matrix(scan("propox.dat",skip=13),ncol=32,byrow=T))
datac <- ifelse(data>0,data,0.5)
censor <- ifelse(data>0,1,-1)
ctimes <- matrix(rep(c(0.01,c(1/12,0.25,1,2,3,6,9,24),
       c(1/12,0.25,1,2,3,6,9,24)+24,c(1/12,0.25,1,2,3,6,9,24)+
       48,c(1/12,0.25,1,2,3,6,9,24)+72),8),ncol=33,byrow=T)
respc <- restovec(datac,times=ctimes,censor=censor,delta=0.1)

times <- as.vector(t(matrix(rep(c(0.01,rep(c(1/12,0.25,1,2,3,6,9,24),4)),8),
      ncol=33,byrow=T)))
trt <- rbind(c(rep(1,9),rep(2,8),rep(3,8),rep(4,8)),
	c(rep(4,9),rep(3,8),rep(2,8),rep(1,8)),
	c(rep(2,9),rep(4,8),rep(1,8),rep(3,8)),
	c(rep(3,9),rep(1,8),rep(4,8),rep(2,8)),
	c(rep(3,9),rep(1,8),rep(4,8),rep(2,8)),
	c(rep(2,9),rep(4,8),rep(1,8),rep(3,8)),
	c(rep(4,9),rep(3,8),rep(2,8),rep(1,8)),
	c(rep(1,9),rep(2,8),rep(3,8),rep(4,8)))
trtA <- as.vector(t(rbind(c(rep(1,15),rep(0,18)),
	c(rep(0,24),rep(1,9)),
	c(rep(0,16),rep(1,15),rep(0,2)),
	c(rep(0,8),rep(1,15),rep(0,10)),
	c(rep(0,8),rep(1,15),rep(0,10)),
	c(rep(0,16),rep(1,15),rep(0,2)),
	c(rep(0,24),rep(1,9)),
	c(rep(1,15),rep(0,18)))))
timesA <- as.vector(t(rbind(c(ctimes[1,1:15],rep(0,18)),
	c(rep(0,24),ctimes[1,1:9]),
	c(rep(0,16),ctimes[1,1:15],rep(0,2)),
	c(rep(0,8),ctimes[1,1:15],rep(0,10)),
	c(rep(0,8),ctimes[1,1:15],rep(0,10)),
	c(rep(0,16),ctimes[1,1:15],rep(0,2)),
	c(rep(0,24),ctimes[1,1:9]),
	c(ctimes[1,1:15],rep(0,18)))))
trtB <- as.vector(t(rbind(c(rep(0,8),rep(1,15),rep(0,10)),
	c(rep(0,16),rep(1,15),rep(0,2)),
	c(rep(1,15),rep(0,18)),
	c(rep(0,24),rep(1,9)),
	c(rep(0,24),rep(1,9)),
	c(rep(1,15),rep(0,18)),
	c(rep(0,16),rep(1,15),rep(0,2)),
	c(rep(0,8),rep(1,15),rep(0,10)))))
timesB <- as.vector(t(rbind(c(rep(0,8),ctimes[1,1:15],rep(0,10)),
	c(rep(0,16),ctimes[1,1:15],rep(0,2)),
	c(ctimes[1,1:15],rep(0,18)),
	c(rep(0,24),ctimes[1,1:9]),
	c(rep(0,24),ctimes[1,1:9]),
	c(ctimes[1,1:15],rep(0,18)),
	c(rep(0,16),ctimes[1,1:15],rep(0,2)),
	c(rep(0,8),ctimes[1,1:15],rep(0,10)))))
trtC <- as.vector(t(rbind(c(rep(0,16),rep(1,15),rep(0,2)),
	c(rep(0,8),rep(1,15),rep(0,10)),
	c(rep(0,24),rep(1,9)),
	c(rep(1,15),rep(0,18)),
	c(rep(1,15),rep(0,18)),
	c(rep(0,24),rep(1,9)),
	c(rep(0,8),rep(1,15),rep(0,10)),
	c(rep(0,16),rep(1,15),rep(0,2)))))
timesC <- as.vector(t(rbind(c(rep(0,16),ctimes[1,1:15],rep(0,2)),
	c(rep(0,8),ctimes[1,1:15],rep(0,10)),
	c(rep(0,24),ctimes[1,1:9]),
	c(ctimes[1,1:15],rep(0,18)),
	c(ctimes[1,1:15],rep(0,18)),
	c(rep(0,24),ctimes[1,1:9]),
	c(rep(0,8),ctimes[1,1:15],rep(0,10)),
	c(rep(0,16),ctimes[1,1:15],rep(0,2)))))
trtD <- as.vector(t(rbind(c(rep(0,24),rep(1,9)),
	c(rep(1,15),rep(0,18)),
	c(rep(0,8),rep(1,15),rep(0,10)),
	c(rep(0,16),rep(1,15),rep(0,2)),
	c(rep(0,16),rep(1,15),rep(0,2)),
	c(rep(0,8),rep(1,15),rep(0,10)),
	c(rep(1,15),rep(0,18)),
	c(rep(0,24),rep(1,9)))))
timesD <- as.vector(t(rbind(c(rep(0,24),ctimes[1,1:9]),
	c(ctimes[1,1:15],rep(0,18)),
	c(rep(0,8),ctimes[1,1:15],rep(0,10)),
	c(rep(0,16),ctimes[1,1:15],rep(0,2)),
	c(rep(0,16),ctimes[1,1:15],rep(0,2)),
	c(rep(0,8),ctimes[1,1:15],rep(0,10)),
	c(ctimes[1,1:15],rep(0,18)),
	c(rep(0,24),ctimes[1,1:9]))))

dataA <- rbind(data[1,1:9],data[2,25:33],data[3,17:25],data[4:5,9:17],
		data[6,17:25],data[7,25:33],data[8,1:9])

if(interactive()){
main <- c("ABCD (Subjects 1 and 4)","BDAC (Subjects 2 and 3)",
	"CADB (Subjects 2 and 3)","DCBA (Subjects 1 and 4)")
ylab <- c("Propoxyphene (microg/l)","","Propoxyphene (microg/l)","")
xlab <- c("","","Hours","Hours")
ind <- c(1,3,5,7)
postscript("propoxpr.eps")
par(mfrow=c(2,2),font.main=1)
plot(ctimes[1,],datac[1,],main=main[1],
	ylim=c(0,260),type="l",xlab=xlab[1],ylab=ylab[1])
lines(ctimes[1,],datac[8,],lty="4212")
plot(ctimes[1,],datac[3,],main=main[2],lty=2,
	ylim=c(0,260),type="l",xlab=xlab[2],ylab=ylab[2])
lines(ctimes[1,],datac[6,],lty=3)
plot(ctimes[1,],datac[4,],main=main[3],lty=2,
	ylim=c(0,260),type="l",xlab=xlab[3],ylab=ylab[3])
lines(ctimes[1,],datac[5,],lty=3)
plot(ctimes[1,],datac[2,],main=main[4],
	ylim=c(0,260),type="l",xlab=xlab[4],ylab=ylab[4])
lines(ctimes[1,],datac[7,],lty="4212")
}

mu0A <- function(p){
	ka <- exp(p[2])
	ke <- exp(p[3])
	rep(dataA[,1],rep(9,8))+ka/(exp(p[1])*(ka-ke))*(exp(-ke*times[1:9])-exp(-ka*times[1:9]))}
print(z0Agn <- gnlr(as.vector(t(dataA)),"normal",mu=mu0A,
	pmu=c(3,0,-2.6),psh=7.6))
if(interactive()){
plot(times[1:9],dataA[1,],ylim=c(0,250))
for(i in 2:8)points(times[1:9],dataA[i,],pch=i)
lines(times[1:9],mu0A(z0Agn$coef)[seq(1,66,by=8)])
}

print(z0An <- gar(dataA,times=ctimes[,1:9],"normal",mu=mu0A,
	preg=c(-4.3,0,-2),pdep=0.8,psh=40))
if(interactive()){
plot(times[1:9],dataA[1,],ylim=c(0,250))
for(i in 2:8)points(times[1:9],dataA[i,],pch=i)
lines(times[1:9],mu0A(z0An$coef)[1:9])
}

mua <- function(p){
	kaA <- exp(p[2])
	kaB <- exp(p[4])
	kaC <- exp(p[5])
	kaD <- exp(p[6])
	ke <- exp(p[3])
	trtA*kaA/(exp(p[1])*(kaA-ke))*(exp(-ke*timesA)-exp(-kaA*timesA))+
	trtB*kaB/(exp(p[1])*(kaB-ke))*(exp(-ke*timesB)-exp(-kaB*timesB))+
	trtC*kaC/(exp(p[1])*(kaC-ke))*(exp(-ke*timesC)-exp(-kaC*timesC))+
	trtD*kaD/(exp(p[1])*(kaD-ke))*(exp(-ke*timesD)-exp(-kaD*timesD))}

print(zan <- gar(respc,"normal",mu=mua,preg=c(-5,-1,-1.1,-1,1,-1),
	pdep=0.6,psh=40))
print(zag <- gar(respc,"gamma",mu=mua,
	preg=c(-5.6,-1,-1.1,-1,1,-1),pdep=0.1,psh=0.5))
print(zaw <- gar(respc,"Weibull",mu=mua,
	preg=c(-5.6,-1,-1.1,-1,1,-1),pdep=0.6,psh=0.5))
print(zaln <- gar(respc,"normal",mu=mua,
	trans="log",link="exp",preg=c(-5.6,-1,-1.1,-1,1,-1),pdep=0.6,psh=3.5))
print(zall <- gar(respc,"logistic",mu=mua,
	trans="log",link="exp",preg=c(-5.6,-1,-1.1,-1,1,-1),pdep=0.6,psh=3.5))
print(zalc <- gar(respc,"Cauchy",mu=mua,
	trans="log",link="exp",preg=c(-5.6,-1,-1.1,-1,1,-1),pdep=0.6,psh=3.5))

if(interactive()){
#postscript("propox.eps")
par(mfrow=c(2,2),font.main=1)
for(i in 1:4){
	plot(ctimes[1,],muai(zalc$coef)[(1:33)+(ind[i]-1)*33],ylim=c(0,260),
		main=main[i],type="l",xlab="Hours",
		ylab="Propoxyphene (microg/l)")
	plot(iprofile(zalc),nind=ind[i],pch=1,lty=2,add=T)}
}

mue <- function(p){
	kaA <- exp(p[2])
	kaB <- exp(p[2])
	kaC <- exp(p[2])
	kaD <- exp(p[2])
	keA <- exp(p[3])
	keB <- exp(p[4])
	keC <- exp(p[5])
	keD <- exp(p[6])
	trtA*kaA/(exp(p[1])*(kaA-keA))*(exp(-keA*timesA)-exp(-kaA*timesA))+
	trtB*kaB/(exp(p[1])*(kaB-keB))*(exp(-keB*timesB)-exp(-kaB*timesB))+
	trtC*kaC/(exp(p[1])*(kaC-keC))*(exp(-keC*timesC)-exp(-kaC*timesC))+
	trtD*kaD/(exp(p[1])*(kaD-keD))*(exp(-keD*timesD)-exp(-kaD*timesD))}

print(zelc <- gar(respc,"Cauchy",mu=mue,trans="log",link="exp",
	preg=c(-5.6,-1,-1.1,-1.1,-1.1,-1.1),pdep=0.6,psh=40))

if(interactive()){
plot(ctimes[1,],mue(zelc$coef)[1:33],type="l",ylim=c(0,150))
lines(ctimes[2,],mue(zelc$coef)[34:66],lty=2)
points(ctimes[1,],data[1,])
points(ctimes[2,],data[2,],pch=2)
}

muv <- function(p){
	kaA <- exp(p[2])
	kaB <- exp(p[2])
	kaC <- exp(p[2])
	kaD <- exp(p[2])
	keA <- exp(p[3])
	keB <- exp(p[3])
	keC <- exp(p[3])
	keD <- exp(p[3])
	trtA*kaA/(exp(p[1])*(kaA-keA))*(exp(-keA*timesA)-exp(-kaA*timesA))+
	trtB*kaB/(exp(p[4])*(kaB-keB))*(exp(-keB*timesB)-exp(-kaB*timesB))+
	trtC*kaC/(exp(p[5])*(kaC-keC))*(exp(-keC*timesC)-exp(-kaC*timesC))+
	trtD*kaD/(exp(p[6])*(kaD-keD))*(exp(-keD*timesD)-exp(-kaD*timesD))}

print(zvlc <- gar(respc,"Cauchy",mu=muv,trans="log",link="exp",
	preg=c(-5.6,-1,-1.1,-5,-1,-5),pdep=0.6,psh=40))

if(interactive()){
plot(ctimes[1,],muv(zvlc$coef)[1:33],type="l",ylim=c(0,150))
lines(ctimes[2,],muv(zvlc$coef)[34:66],lty=2)
points(ctimes[1,],data[1,])
points(ctimes[2,],data[2,],pch=2)
}

muav <- function(p){
	kaA <- exp(p[2])
	kaB <- exp(p[7])
	kaC <- exp(p[8])
	kaD <- exp(p[9])
	keA <- exp(p[3])
	keB <- exp(p[3])
	keC <- exp(p[3])
	keD <- exp(p[3])
	trtA*kaA/(exp(p[1])*(kaA-keA))*(exp(-keA*timesA)-exp(-kaA*timesA))+
	trtB*kaB/(exp(p[4])*(kaB-keB))*(exp(-keB*timesB)-exp(-kaB*timesB))+
	trtC*kaC/(exp(p[5])*(kaC-keC))*(exp(-keC*timesC)-exp(-kaC*timesC))+
	trtD*kaD/(exp(p[6])*(kaD-keD))*(exp(-keD*timesD)-exp(-kaD*timesD))}

print(zavlc <- gar(respc,"Cauchy",mu=muav,trans="log",link="exp",
	preg=c(-5.5,-1.4,-1,-5.5,-4.1,-5.3,-1.4,3,-1.3),pdep=0.65,psh=35))

if(interactive()){
plot(ctimes[1,],muav(zavlc$coef)[1:33],type="l",ylim=c(0,150))
lines(ctimes[2,],muav(zavlc$coef)[34:66],lty=2)
points(ctimes[1,],data[1,])
points(ctimes[2,],data[2,],pch=2)
}

muae <- function(p){
	kaA <- exp(p[2])
	kaB <- exp(p[7])
	kaC <- exp(p[8])
	kaD <- exp(p[9])
	keA <- exp(p[3])
	keB <- exp(p[4])
	keC <- exp(p[5])
	keD <- exp(p[6])
	trtA*kaA/(exp(p[1])*(kaA-keA))*(exp(-keA*timesA)-exp(-kaA*timesA))+
	trtB*kaB/(exp(p[1])*(kaB-keB))*(exp(-keB*timesB)-exp(-kaB*timesB))+
	trtC*kaC/(exp(p[1])*(kaC-keC))*(exp(-keC*timesC)-exp(-kaC*timesC))+
	trtD*kaD/(exp(p[1])*(kaD-keD))*(exp(-keD*timesD)-exp(-kaD*timesD))}

print(zaelc <- gar(respc,"Cauchy",mu=muae,iter=200,trans="log",link="exp",
	preg=c(-5.5,-1.4,-1,-1,-1,-1,-1.4,2,-1.3),pdep=0.65,psh=35))

if(interactive()){
plot(ctimes[1,],muae(zaelc$coef)[1:33],type="l",ylim=c(0,150))
lines(ctimes[2,],muae(zaelc$coef)[34:66],lty=2)
points(ctimes[1,],data[1,])
points(ctimes[2,],data[2,],pch=2)
}

muaev <- function(p){
	kaA <- exp(p[2])
	kaB <- exp(p[7])
	kaC <- exp(p[8])
	kaD <- exp(p[9])
	keA <- exp(p[3])
	keB <- exp(p[4])
	keC <- exp(p[5])
	keD <- exp(p[6])
	trtA*kaA/(exp(p[1])*(kaA-keA))*(exp(-keA*timesA)-exp(-kaA*timesA))+
	trtB*kaB/(exp(p[10])*(kaB-keB))*(exp(-keB*timesB)-exp(-kaB*timesB))+
	trtC*kaC/(exp(p[11])*(kaC-keC))*(exp(-keC*timesC)-exp(-kaC*timesC))+
	trtD*kaD/(exp(p[12])*(kaD-keD))*(exp(-keD*timesD)-exp(-kaD*timesD))}

print(zaevlc <- gar(respc,"Cauchy",mu=muaev,iter=200,trans="log",link="exp",
	preg=c(-0.3,-0.15,-3,-2.9,-3.4,-2.9,-0.5,2.9,1,-0.9,-0.7,-0.5),
	pdep=0.65,psh=0.25))

if(interactive()){
plot(ctimes[1,],muaev(zaevlc$coef)[1:33],type="l",ylim=c(0,150))
lines(ctimes[2,],muaev(zaevlc$coef)[34:66],lty=2)
points(ctimes[1,],data[1,])
points(ctimes[2,],data[2,],pch=2)
}

muai <- function(p){
	kaA <- exp(p[2])
	kaB <- exp(p[4])
	kaD <- exp(p[5])
	keA <- keB <- keC <- keD <- exp(p[3])
	trtA*kaA/(exp(p[1])*(kaA-keA))*(exp(-keA*timesA)-exp(-kaA*timesA))+
	trtB*kaB/(exp(p[1])*(kaB-keB))*(exp(-keB*timesB)-exp(-kaB*timesB))+
	trtC*(((1-exp(-keC*timesC))*(timesC<=(1/12))+(1-exp(-keC/12))*exp(-keC*timesC-1/12)*(timesC>(1/12)))/(exp(p[6])*keC))+
	trtD*kaD/(exp(p[1])*(kaD-keD))*(exp(-keD*timesD)-exp(-kaD*timesD))}

print(zain <- gar(respc,"normal",mu=muai,iter=200,
	preg=c(-4.85,-0.24,-1.74,-0.5,1.37,-1),pdep=0.65,psh=35))
print(zaig <- gar(respc,"gamma",mu=muai,iter=200,
	preg=c(-4.85,-0.24,-1.74,-0.5,1.37,-1),pdep=0.65,psh=2))
print(zaiw <- gar(respc,"Weibull",mu=muai,iter=200,
	preg=c(-4.64,-0.63,-2.26,-1,1.83,-7.13),pdep=0.65,psh=0.5))
print(zailn <- gar(respc,"normal",mu=muai,iter=200,trans="log",link="exp",
	preg=c(-4.64,-0.63,-2.26,-1,1.83,-7.13),pdep=0.65,psh=3.5))
print(zaill <- gar(respc,"logistic",mu=muai,iter=200,trans="log",link="exp",
	preg=c(-4.64,-0.63,-2.26,-1,1.83,-7.13),pdep=0.65,psh=2))
print(zailc <- gar(respc,"Cauchy",mu=muai,iter=200,trans="log",link="exp",
	preg=c(-4.64,-0.63,-2.26,-1,1.83,-7.13),pdep=0.65,psh=2))

muai2 <- function(p){
	kaA <- kaB <- kaD <- exp(p[2])
	keA <- keB <- keC <- keD <- exp(p[3])
	trtA*kaA/(exp(p[1])*(kaA-keA))*(exp(-keA*timesA)-exp(-kaA*timesA))+
	trtB*kaB/(exp(p[1])*(kaB-keB))*(exp(-keB*timesB)-exp(-kaB*timesB))+
	trtC*(((1-exp(-keC*timesC))*(timesC<=(1/12))+(1-exp(-keC/12))*exp(-keC*timesC-1/12)*(timesC>(1/12)))/(exp(p[4])*keC))+
	trtD*kaD/(exp(p[1])*(kaD-keD))*(exp(-keD*timesD)-exp(-kaD*timesD))}
print(zailc2 <- gar(respc,"Cauchy",mu=muai2,iter=200,trans="log",link="exp",
	preg=c(-4.64,-0.63,-2.26,-7.13),pdep=0.65,psh=2))

muaiv <- function(p){
	kaA <- exp(p[2])
	kaB <- exp(p[4])
	kaD <- exp(p[5])
	keA <- keB <- keC <- keD <- exp(p[3])
	p[7]+
	trtA*kaA/(exp(p[1])*(kaA-keA))*(exp(-keA*timesA)-exp(-kaA*timesA))+
	trtB*kaB/(exp(p[1])*(kaB-keB))*(exp(-keB*timesB)-exp(-kaB*timesB))+
	trtC*(((1-exp(-keC*timesC))*(timesC<=(1/12))+(1-exp(-keC/12))*exp(-keC*timesC-1/12)*(timesC>(1/12)))/(exp(p[6])*keC))+
	trtD*kaD/(exp(p[1])*(kaD-keD))*(exp(-keD*timesD)-exp(-kaD*timesD))}
muaiv2 <- function(p){
	kaA <- exp(p[2])
	kaB <- exp(p[4])
	kaD <- exp(p[5])
	keA <- keB <- keC <- keD <- exp(p[3])
	(p[7]+
	trtA*kaA/(exp(p[1])*(kaA-keA))*(exp(-keA*timesA)-exp(-kaA*timesA))+
	trtB*kaB/(exp(p[1])*(kaB-keB))*(exp(-keB*timesB)-exp(-kaB*timesB))+
	trtC*(((1-exp(-keC*timesC))*(timesC<=(1/12))+(1-exp(-keC/12))*exp(-keC*timesC-1/12)*(timesC>(1/12)))/(exp(p[6])*keC))+
	trtD*kaD/(exp(p[1])*(kaD-keD))*(exp(-keD*timesD)-exp(-kaD*timesD)))^2}
print(zaivn <- gar(respc,"normal",
	mu=muai,iter=200,preg=c(-4.56,-0.28,-2.15,-0.5,1.57,-7),shape=muaiv2,
	pdep=0.65,psh=c(-4,0.012,-1,-0.67,2,-6.4,7)))
print(zaivn2 <- gar(respc,"normal",
	mu=muai,iter=200,preg=c(-4.56,-0.28,-2.15,-0.5,1.57,-7),shape=muaiv,
	pdep=0.65,psh=c(-4,0.012,-1,-0.67,2,-6,7)))
print(zaivg <- gar(respc,"gamma",mu=muai,iter=200,shape=muaiv,
	preg=c(-4.74,-0.73,-1.37,-0.87,1.48,-6.86),pdep=0.8,
	psh=c(-1.94,-2.28,-3.06,-1.38,1.04,-3.82,-0.007)))
print(zaivw <- gar(respc,"Weibull",mu=muai,iter=200,shape=muaiv,
	preg=c(-4.65,-0.58,-1.45,-0.97,1.36,-6.97),pdep=0.96,
	psh=c(-1.1,-2.1,-2.6,-1.5,0.2,-2.6,0.6)))
print(zaivln <- gar(respc,"normal",
	mu=muai,iter=200,trans="log",link="exp",shape=muaiv2,
	preg=c(3,-0.35,,-2.2,-0.3,1.2,3),pdep=0.95,
	psh=c(-4.5,-0.4,4,-0.6,0.1,-4.8,0.4)))
print(zaivln2 <- gar(respc,"normal",
	mu=muai,iter=200,trans="log",link="exp",shape=muaiv,
	preg=c(3,-0.35,,-2.2,-0.3,1.2,3),pdep=0.95,
	psh=c(-4.5,-0.4,4,-0.6,0.1,-4.8,0.4)))
print(zaivll <- gar(respc,"logistic",
	mu=muai,iter=200,trans="log",link="exp",shape=muaiv,
	preg=c(3,-0.35,,-2.2,-0.3,1.2,3),pdep=0.95,
	psh=c(-3.2,-0.3,3.6,-0.4,0.5,-4,0.2)))
print(zaivlc <- gar(respc,"Cauchy",
	mu=muai,iter=200,trans="log",link="exp",shape=muaiv,
	preg=c(3,-0.35,,-2.2,-0.3,1.2,3),pdep=0.8,
	psh=c(-0.5,0.1,1,-0.26,3.2,-2.3,0.2)))

muai2 <- function(p){
	kaA <- kaB <- kaD <- exp(p[2])
	keA <- keB <- keC <- keD <- exp(p[3])
	trtA*kaA/(exp(p[1])*(kaA-keA))*(exp(-keA*timesA)-exp(-kaA*timesA))+
	trtB*kaB/(exp(p[1])*(kaB-keB))*(exp(-keB*timesB)-exp(-kaB*timesB))+
	trtC*(((1-exp(-keC*timesC))*(timesC<=(1/12))+(1-exp(-keC/12))*exp(-keC*timesC-1/12)*(timesC>(1/12)))/(exp(p[4])*keC))+
	trtD*kaD/(exp(p[1])*(kaD-keD))*(exp(-keD*timesD)-exp(-kaD*timesD))}
muai2a <- function(p){
	kaA <- kaB <- exp(p[2])
	kaD <- exp(p[4])
	keA <- keB <- keC <- keD <- exp(p[3])
	trtA*kaA/(exp(p[1])*(kaA-keA))*(exp(-keA*timesA)-exp(-kaA*timesA))+
	trtB*kaB/(exp(p[1])*(kaB-keB))*(exp(-keB*timesB)-exp(-kaB*timesB))+
	trtC*(((1-exp(-keC*timesC))*(timesC<=(1/12))+(1-exp(-keC/12))*exp(-keC*timesC-1/12)*(timesC>(1/12)))/(exp(p[5])*keC))+
	trtD*kaD/(exp(p[1])*(kaD-keD))*(exp(-keD*timesD)-exp(-kaD*timesD))}

print(zai2lc <- gar(respc,"Cauchy",mu=muai2,iter=200,trans="log",link="exp",
	preg=c(-4.64,-0.63,-2.26,-7.13),pdep=0.65,psh=2))

print(zaiv2g <- gar(respc,"gamma",mu=muai2a,iter=200,shape=muaiv,
	preg=c(-4.74,-0.73,-1.37,1.48,-6.86),pdep=0.8,
	psh=c(-1.94,-2.28,-3.06,-1.38,1.04,-3.82,-0.007)))
print(zaiv2lc <- gar(respc,"Cauchy",
	mu=muai2,iter=200,trans="log",link="exp",shape=muaiv,
	preg=c(-4.64,-0.63,-2.26,-7.13),pdep=0.65,
	psh=c(-0.5,0.074,1,-0.26,3.2,-2.36,0.19)))

if(interactive()){
muai2ap <- function(p){
	kaA <- kaB <- exp(p[2])
	kaD <- exp(p[4])
	keA <- keB <- keC <- keD <- exp(p[3])
	trtAp*kaA/(exp(p[1])*(kaA-keA))*(exp(-keA*timesAp)-exp(-kaA*timesAp))+
	trtBp*kaB/(exp(p[1])*(kaB-keB))*(exp(-keB*timesBp)-exp(-kaB*timesBp))+
	trtCp*(((1-exp(-keC*timesCp))*(timesCp<=(1/12))+(1-exp(-keC/12))*exp(-keC*timesCp-1/12)*(timesCp>(1/12)))/(exp(p[5])*keC))+
	trtDp*kaD/(exp(p[1])*(kaD-keD))*(exp(-keD*timesDp)-exp(-kaD*timesDp))}
ptime <- seq(0.01,96,by=1)
trtAp <- as.vector(t(rbind(c(rep(1,30),rep(0,18)),
	c(rep(0,72),rep(1,24)),
	c(rep(0,48),rep(1,30),rep(0,18)),
	c(rep(0,24),rep(1,30),rep(0,42)),
	c(rep(0,24),rep(1,30),rep(0,42)),
	c(rep(0,48),rep(1,30),rep(0,18)),
	c(rep(0,72),rep(1,24)),
	c(rep(1,30),rep(0,18)))))
trtBp <- as.vector(t(rbind(c(rep(0,24),rep(1,30),rep(0,42)),
	c(rep(0,48),rep(1,30),rep(0,18)),
	c(rep(1,30),rep(0,18)),
	c(rep(0,72),rep(1,24)),
	c(rep(0,72),rep(1,24)),
	c(rep(1,30),rep(0,18)),
	c(rep(0,48),rep(1,30),rep(0,18)),
	c(rep(0,24),rep(1,30),rep(0,42)))))
trtCp <- as.vector(t(rbind(c(rep(0,48),rep(1,30),rep(0,18)),
	c(rep(0,24),rep(1,30),rep(0,42)),
	c(rep(0,72),rep(1,24)),
	c(rep(1,30),rep(0,18)),
	c(rep(1,30),rep(0,18)),
	c(rep(0,72),rep(1,24)),
	c(rep(0,24),rep(1,30),rep(0,42)),
	c(rep(0,48),rep(1,30),rep(0,18)))))
trtDp <- as.vector(t(rbind(c(rep(0,72),rep(1,24)),
	c(rep(1,30),rep(0,18)),
	c(rep(0,24),rep(1,30),rep(0,42)),
	c(rep(0,48),rep(1,30),rep(0,18)),
	c(rep(0,48),rep(1,30),rep(0,18)),
	c(rep(0,24),rep(1,30),rep(0,42)),
	c(rep(1,30),rep(0,18)),
	c(rep(0,72),rep(1,24)))))
timesAp <- as.vector(t(rbind(c(ptime[1:30],rep(0,66)),
	c(rep(0,72),ptime[1:24]),
	c(rep(0,48),ptime[1:30],rep(0,18)),
	c(rep(0,24),ptime[1:30],rep(0,42)),
	c(rep(0,24),ptime[1:30],rep(0,42)),
	c(rep(0,48),ptime[1:30],rep(0,18)),
	c(rep(0,72),ptime[1:24]),
	c(ptime[1:30],rep(0,66)))))
timesBp <- as.vector(t(rbind(c(rep(0,24),ptime[1:30],rep(0,42)),
	c(rep(0,48),ptime[1:30],rep(0,18)),
	c(ptime[1:30],rep(0,66)),
	c(rep(0,72),ptime[1:24]),
	c(rep(0,72),ptime[1:24]),
	c(ptime[1:30],rep(0,66)),
	c(rep(0,48),ptime[1:30],rep(0,18)),
	c(rep(0,24),ptime[1:30],rep(0,42)))))
timesCp <- as.vector(t(rbind(c(rep(0,48),ptime[1:30],rep(0,18)),
	c(rep(0,24),ptime[1:30],rep(0,42)),
	c(rep(0,72),ptime[1:24]),
	c(ptime[1:30],rep(0,66)),
	c(ptime[1:30],rep(0,66)),
	c(rep(0,72),ptime[1:24]),
	c(rep(0,24),ptime[1:30],rep(0,42)),
	c(rep(0,48),ptime[1:30],rep(0,18)))))
timesDp <- as.vector(t(rbind(c(rep(0,72),ptime[1:24]),
	c(ptime[1:30],rep(0,66)),
	c(rep(0,24),ptime[1:30],rep(0,42)),
	c(rep(0,48),ptime[1:30],rep(0,18)),
	c(rep(0,48),ptime[1:30],rep(0,18)),
	c(rep(0,24),ptime[1:30],rep(0,42)),
	c(ptime[1:30],rep(0,66)),
	c(rep(0,72),ptime[1:24]))))
main <- c("ABCD (Subject 1)","BDAC (Subject 2)",
	"CADB (Subject 3)","DCBA (Subject 4)")
ylab <- c("Propoxyphene (microg/l)","","Propoxyphene (microg/l)","")
xlab <- c("","","Hours","Hours")
ind <- c(1,3,5,7)
postscript("propox.eps")
par(mfrow=c(2,2),font.main=1)
for(i in 1:4){
	plot(ptime,muai2ap(zaiv2g$coef)[(1:96)+(ind[i]-1)*96],
		main=main[i],ylim=c(0,260),type="l",xlab=xlab[i],ylab=ylab[i])
	plot(iprofile(zaiv2g),nind=ind[i],pch=1,lty=2,add=T)}
}

muai3 <- function(p){
	kaA <- kaB <- exp(p[2])
	kaD <- exp(p[5])
	keA <- keB <- keC <- exp(p[3])
	keD <- exp(p[6])
	trtA*kaA/(exp(p[1])*(kaA-keA))*(exp(-keA*timesA)-exp(-kaA*timesA))+
	trtB*kaB/(exp(p[1])*(kaB-keB))*(exp(-keB*timesB)-exp(-kaB*timesB))+
	trtC*(((1-exp(-keC*timesC))*(timesC<=(1/12))+(1-exp(-keC/12))*exp(-keC*timesC-1/12)*(timesC>(1/12)))/(exp(p[4])*keC))+
	trtD*kaD/(exp(p[7])*(kaD-keD))*(exp(-keD*timesD)-exp(-kaD*timesD))}

print(zai3lc <- gar(respc,"Cauchy",mu=muai3,iter=200,trans="log",link="exp",
	preg=c(-4.64,-0.63,-2.26,-7.13,-0.63,-2.26,-4.64),pdep=0.65,psh=2))

muai4 <- function(p){
	kaA <- kaB <- exp(p[2])
	keA <- keB <- exp(p[3])
	keC <- exp(p[5])
	keD <- exp(p[6])
	trtA*kaA/(exp(p[1])*(kaA-keA))*(exp(-keA*timesA)-exp(-kaA*timesA))+
	trtB*kaB/(exp(p[1])*(kaB-keB))*(exp(-keB*timesB)-exp(-kaB*timesB))+
	trtC*(((1-exp(-keC*timesC))*(timesC<=(1/12))+(1-exp(-keC/12))*exp(-keC*timesC-1/12)*(timesC>(1/12)))/(exp(p[4])*keC))+
	trtD*(((1-exp(-keD*timesD))*(timesD<=(1/12))+(1-exp(-keD/12))*exp(-keD*timesD-1/12)*(timesD>(1/12)))/(exp(p[7])*keD))}
print(zai4lc <- gar(respc,"Cauchy",mu=muai4,iter=200,trans="log",link="exp",
	preg=c(-4.64,-0.63,-2.26,-3,-0.63,-0.5,-1),pdep=0.65,psh=2))

muai5 <- function(p){
	kaA <- kaB <- exp(p[2])
	keA <- keB <- exp(p[3])
	keC <- keD <- exp(p[5])
	trtA*kaA/(exp(p[1])*(kaA-keA))*(exp(-keA*timesA)-exp(-kaA*timesA))+
	trtB*kaB/(exp(p[1])*(kaB-keB))*(exp(-keB*timesB)-exp(-kaB*timesB))+
	trtC*(((1-exp(-keC*timesC))*(timesC<=(1/12))+(1-exp(-keC/12))*exp(-keC*timesC-1/12)*(timesC>(1/12)))/(exp(p[4])*keC))+
	trtD*(((1-exp(-keD*timesD))*(timesD<=(1/12))+(1-exp(-keD/12))*exp(-keD*timesD-1/12)*(timesD>(1/12)))/(exp(p[4])*keD))}
print(zai5lc <- gar(respc,"Cauchy",mu=muai5,iter=200,trans="log",link="exp",
	preg=c(-4.64,-0.63,-2.26,-3,-3),pdep=0.95,psh=2))
